> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.senjaropay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.senjaropay.com/_mcp/server.

# List merchant transactions

POST https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions
Content-Type: application/json

Reference: https://docs.senjaropay.com/api-documentation/collections/list-transactions

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: SenjaroPay API
  version: 1.0.0
paths:
  /senjaropay/merchant/payments/listTransactions:
    post:
      operationId: listTransactions
      summary: List merchant transactions
      tags:
        - subpackage_collections
      parameters:
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Transaction list
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListTransactionsResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              additionalProperties:
                description: Any type
servers:
  - url: https://api.senjaropay.com
    description: SenjaroPay API
components:
  schemas:
    Transaction:
      type: object
      properties:
        id:
          type: string
          format: uuid
        transaction_reference_id:
          type: string
        reference_id:
          type: string
          format: uuid
        amount:
          type: string
        currency:
          type: string
        status:
          type: string
        method:
          type: string
        main_channel:
          type: string
        sub_channel:
          type: string
        channel_reference:
          type: string
        customer_phone:
          type: string
        customer_email:
          type:
            - string
            - 'null'
        created_at:
          type: string
          format: date-time
      title: Transaction
    ListTransactionsResponse:
      type: object
      properties:
        status:
          type: string
        merchant_id:
          type: string
          format: uuid
        count:
          type: integer
        data:
          type: array
          items:
            $ref: '#/components/schemas/Transaction'
      title: ListTransactionsResponse
    ApiError:
      type: object
      properties:
        status:
          type: string
        code:
          type: integer
        error_code:
          type: string
        message:
          type: string
      title: ApiError
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
    apiSecretAuth:
      type: apiKey
      in: header
      name: x-api-secret

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "status": "success",
  "merchant_id": "string",
  "count": 7,
  "data": [
    {
      "id": "string",
      "transaction_reference_id": "string",
      "reference_id": "string",
      "amount": "1000.00",
      "currency": "TZS",
      "status": "PENDING",
      "method": "MOBILE",
      "main_channel": "senjaropay",
      "sub_channel": "Mobile Money",
      "channel_reference": "S20506982280",
      "customer_phone": "255700000001",
      "customer_email": "string",
      "created_at": "2026-04-17T09:42:06.000Z"
    }
  ]
}
```

**SDK Code**

```python collections_listTransactions_example
import requests

url = "https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions"

payload = {}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript collections_listTransactions_example
const url = 'https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go collections_listTransactions_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby collections_listTransactions_example
require 'uri'
require 'net/http'

url = URI("https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java collections_listTransactions_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php collections_listTransactions_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp collections_listTransactions_example
using RestSharp;

var client = new RestClient("https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift collections_listTransactions_example
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.senjaropay.com/senjaropay/merchant/payments/listTransactions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```